#include	<sys/ipc.h>
#include	<sys/shm.h>
#include	<sys/types.h>	/* basic system data types */
#include	<sys/socket.h>	/* basic socket definitions */
#include	<sys/time.h>	/* timeval{} for select() */
#include	<time.h>		/* timespec{} for pselect() */
#include	<netinet/in.h>	/* sockaddr_in{} and other Internet defns */
#include	<arpa/inet.h>	/* inet(3) functions */
#include	<errno.h>
#include	<fcntl.h>		/* for nonblocking */
#include	<netdb.h>
#include	<signal.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<sys/stat.h>	/* for S_xxx file mode constants */
#include	<sys/uio.h>		/* for iovec{} and readv/writev */
#include	<unistd.h>
#include	<sys/wait.h>
#include	<sys/un.h>		/* for Unix domain sockets */
#include	<sys/times.h>
#include	<limits.h>
#define	LISTENQ		1024
#define	MAXLINE		4096	/* max text line length */
#define	MAXSOCKADDR  128	/* max socket address structure size */
#define	BUFFSIZE	8192	/* buffer size for reads and writes */
#define RouterListenPort 7788
#define EUListenPort 7789
#define MAXPKSIZE 1500
#define MAXFNAMELEN 32
#define MAXPAYLOAD 1428 //MAXPKSIZE-40-32
#define MAXPAYLOADUDP 1420 //MAXPAYLOAD-8
#define MAXCHOPSIZE 1300
#define SHMKEY		5678
#define MAXQNum	10	//max number incoming package queues in system
#define MAXBuffNum 200
//#define	MAXFILENAMELEN	64
#define	SHMKEYcp			5676
#define SHMKEYbuffedit		5677
#define SHMKEYbuffout		5678
#define	SHMKEYbuffarout		5679
#define UDPH		17
#define	EDIPH		100
#define TRIDENT		"131.123.32.254"
#define AEGIS		"131.123.32.132"
#define FORRESTAL	"131.123.32.131"
#define IOWA		"131.123.32.22"
#define INTREPID	"131.123.32.25"
#define VENUS		"131.123.32.130"
#define	DAVELINUX	"131.123.48.201"
#define	AWAGATEWAY	"131.123.48.129"
#define FROM_IP		"131.123.32.131"
#define TO_IP		"131.123.32.131"
#define	DAVELAN		"192.168.0.124"
#define	AWALAN		"192.168.0.150"
#define SRCPORT		1234 //use in wrapup, no real use at this time
#define DSTPORT		4321 //use in wrapup, no real use at this time
#define ENDOFSTREAM 0
#define MAXKEYWORDLEN	16  //max keyword len in edip header, 256 maximal
#define	MAXNUMOFFOUND	32	//max keyword found in each stream
#define MAXNUMOFINDEX	4   //max number of indexes in each edip header, 256 maximal
#define MAXKWListLen	32	//max number of keyword in keyword list
#ifndef	INET_ADDRSTRLEN
#define	INET_ADDRSTRLEN		16
#endif


struct chop_t
{
	int			len;
	char		content[MAXCHOPSIZE];
};

struct ipv6_t
{
	uint8_t	version; //different from real ipv6 here
	uint8_t	traf_class; //different from real ipv6 here
	uint16_t	flowtable;
	uint16_t	payloadlen;
	uint8_t	nextheader;
	uint8_t	loplimit;
	char	sourceaddr[16]; //define to char for easier use
	char	destinaddr[16]; //define to char for easier use
	char	filename[MAXFNAMELEN];
	char	payload[MAXPAYLOAD];
};


struct udp_t
{
	uint16_t	sourceport;
	uint16_t	destport;
	uint16_t	length;
	uint16_t	checksum;
	char		payload[MAXPAYLOADUDP];
};

struct pkq_t
{
	int			complete; //0 not a complete stream; 1 complete stream
	int			numofpkg;
	uint16_t	streamid;
	struct	ipv6_t	quepkg[MAXBuffNum];
};

struct searchresult_t
{
	char	keyword[MAXKEYWORDLEN];
	int		keylen;
	int		numofindex;
	int		offset[MAXNUMOFFOUND];
	int		whichpk[MAXNUMOFFOUND];
	int		offsetinpk[MAXNUMOFFOUND];
};

struct shmbuffedit_t
{
	uint8_t	version; //different from real ipv6 here
	uint8_t	traf_class; //different from real ipv6 here
	uint16_t	flowtable;
	uint8_t	nextheader;
	uint8_t	loplimit;
	char	sourceaddr[16]; //define to char for easier use
	char	destinaddr[16]; //define to char for easier use
	uint16_t	sourceport;
	uint16_t	destport;
	char	filename[MAXFNAMELEN];

	char		editable[MAXPAYLOADUDP*MAXBuffNum];
	int			oktoedit;
	int			outbuffempty;
	int			length;

	int			realkwlistlen;
	int			writing;
	struct	searchresult_t searchresult[MAXKWListLen];
};

struct shmbuffcp_t
{
	int		shmwriting;
	int		shmrealsize;
	char	shmbuff[MAXPKSIZE*MAXBuffNum];
};

struct shmbuffarout_t
{
	int		shmwriting;
	int		shmrealsize;
	char	shmbuff[MAXPKSIZE*MAXBuffNum];
};


struct ediph_t
{
	uint8_t		nextheader;
	uint8_t		version;
	uint16_t	checksum;
	uint16_t	reserved;
	uint8_t		keylen;
	uint8_t		numofindex;
	char		keyword[MAXKEYWORDLEN];
	uint16_t	offset[MAXNUMOFINDEX];
};

struct keywordlist_t
{
	int		num;
	char	keyword[MAXKWListLen][MAXKEYWORDLEN];
};



uint16_t cksum(char *buff, int len)
{
	uint32_t sum;
	char temp[MAXPKSIZE];
	char *temp2;
		
	bcopy(buff, temp, len);
	temp2=temp;
	
	sum=0;
	while (len>1) 
	{
		sum +=* ((uint16_t *) temp2)++;
		len-=2;
	}
	if (len)
		sum+=* (uint8_t *)temp2;
	while (sum>>16)
		sum=(sum& 0xffff)+(sum>>16);
	return ~sum;
}


int wrapudp(char *in, struct udp_t *out, int len, int sourceport, int destport)
{
	out->sourceport=sourceport;
	out->destport=destport;
	out->length=len;
	out->checksum=cksum(in, len);
	bcopy(in, out->payload, len);
	return(len+8);
}




void wrapipv6(char *in, struct ipv6_t *out, uint16_t len, char* localaddr, char* targetaddr, uint16_t streamid, uint8_t nexthdr, char *filename)
{
	out->version=6;
	out->traf_class=0;
	out->flowtable=streamid;
	out->payloadlen=len;
	out->nextheader=nexthdr; //0 directpayload
	out->loplimit=0;
	strcpy(out->filename, filename);
	strcpy(out->sourceaddr, localaddr);
	strcpy(out->destinaddr, targetaddr);
	bcopy(in, out->payload, len);
}



void decapip6(char *in, struct ipv6_t *out, int pksize)
{
	bcopy(in, out, pksize);
	//printf("In decapip6: %d\n", out->version);
}

void decapudp(char *in, struct udp_t *out, int pksize)
{
	bcopy(in, out, pksize);
	//printf("In decapudp: checksum %d\n", out->checksum);
	//not real checksum mechanism here, although algorithm is correct
	if (out->checksum!=cksum(out->payload, out->length))
		printf("In decapudp: checksum error, package may damaged\n");
}


int decapedip(char *in, struct shmbuffedit_t *shmbuffedit, char *edippayload, int in_len, int whichpk)
{
	struct ediph_t	ediph;
	int				i, no;
	struct	searchresult_t *searchresult;
	

	//printf("In decapedip: Found edip header!\n");
	bcopy(in, &ediph, sizeof(struct ediph_t));
	if (ediph.keylen>0)
	{
		//printf("Keyword %s appears %d times\n", ediph.keyword, ediph.numofindex);
		for (i=0; i<ediph.numofindex; i++)
		{
			//printf("#%d at offset %d\n", i, ediph.offset[i]);
		}				

		no=-1;
		for (i=0; i<shmbuffedit->realkwlistlen; i++)
		{
			if (bcmp((shmbuffedit->searchresult[i]).keyword, ediph.keyword, ediph.keylen)==0)
			{
				no=i;  //keyword already there
			}
		}
		//if still no=-1, then there's a new keyword
		//make a new entry for new keyword in searchresult
		if (no==-1)
		{
			//printf("keyword is not in searchresult yet, insert as a new one\n");
			bcopy(ediph.keyword, shmbuffedit->searchresult[shmbuffedit->realkwlistlen].keyword, ediph.keylen);
			shmbuffedit->searchresult[shmbuffedit->realkwlistlen].keylen=ediph.keylen;
			no=shmbuffedit->realkwlistlen;
			shmbuffedit->realkwlistlen++;
		}

		//printf("keyword will be at #%d in searchresult\n", no);

		//update searhcresult
		searchresult=&(shmbuffedit->searchresult[no]);
		for (i=0; i<ediph.numofindex; i++)
		{
			searchresult->offsetinpk[searchresult->numofindex]=ediph.offset[i];
			searchresult->whichpk[searchresult->numofindex]=whichpk;
			searchresult->offset[searchresult->numofindex]=whichpk*MAXCHOPSIZE+ediph.offset[i];
			searchresult->numofindex++;
		}
	}
	bcopy(in+sizeof(struct ediph_t), edippayload, in_len-sizeof(struct ediph_t));

	//printf("shmlength%d, realkwlistlen%d, numofindex for keyword[0]%d\n", shmbuffedit->length, shmbuffedit->realkwlistlen, shmbuffedit->searchresult[0].numofindex);
	return (ediph.nextheader);
}

int chop (char *in, int in_len, struct chop_t *choptemp, int chopsize)
{
	int numofchop;
	int chopcharleft;
	int i;
	
	numofchop=in_len/chopsize;
	chopcharleft=in_len%chopsize;
	for ( i=0; i<numofchop; i++)
	{
		choptemp[i].len=chopsize;
		bcopy(in+i*chopsize, choptemp[i].content, chopsize);
	}

	bcopy(in+numofchop*chopsize, choptemp[numofchop].content, chopcharleft);
	choptemp[numofchop].len=chopcharleft;
	numofchop++;

	if (chopcharleft!=0)  //end the stream with a zero-length chop
	{
		choptemp[numofchop].len=ENDOFSTREAM;
		numofchop++;
	}
	return (numofchop);
}




const char *
inet_ntop(int family, const void *addrptr, char *strptr, size_t len)
{
	const u_char *p = (const u_char *) addrptr;

	if (family == AF_INET) {
		char	temp[INET_ADDRSTRLEN];

		snprintf(temp, sizeof(temp), "%d.%d.%d.%d",
				 p[0], p[1], p[2], p[3]);
		if (strlen(temp) >= len) {
			errno = ENOSPC;
			return (NULL);
		}
		strcpy(strptr, temp);
		return (strptr);
	}
	errno = EAFNOSUPPORT;
	return (NULL);
}


static ssize_t
my_read(int fd, char *ptr)
{
	static int	read_cnt = 0;
	static char	*read_ptr;
	static char	read_buf[MAXLINE];

	if (read_cnt <= 0) {
again:
		if ( (read_cnt = read(fd, read_buf, sizeof(read_buf))) < 0) {
			if (errno == EINTR)
				goto again;
			return(-1);
		} else if (read_cnt == 0)
			return(0);
		read_ptr = read_buf;
	}

	read_cnt--;
	*ptr = *read_ptr++;
	return(1);
}

ssize_t						/* Read "n" bytes from a descriptor. */
readn(int fd, void *vptr, size_t n)
{
	size_t	nleft;
	ssize_t	nread;
	char	*ptr;

	ptr = vptr;
	nleft = n;
	while (nleft > 0) {
		if ( (nread = read(fd, ptr, nleft)) < 0) {
			if (errno == EINTR)
				nread = 0;		/* and call read() again */
			else
				return(-1);
		} else if (nread == 0)
			break;				/* EOF */

		nleft -= nread;
		ptr   += nread;
	}
	return(n - nleft);		/* return >= 0 */
}

ssize_t
readline(int fd, void *vptr, size_t maxlen)
{
	int		n, rc;
	char	c, *ptr;

	ptr = vptr;
	for (n = 1; n < maxlen; n++) {
		if ( (rc = my_read(fd, &c)) == 1) {
			*ptr++ = c;
			if (c == '\n')
				break;	/* newline is stored, like fgets() */
		} else if (rc == 0) {
			if (n == 1)
				return(0);	/* EOF, no data read */
			else
				break;		/* EOF, some data was read */
		} else
			return(-1);		/* error, errno set by read() */
	}

	*ptr = 0;	/* null terminate like fgets() */
	return(n);
}



