#include "common.h"
struct tms tmss;

int
main()
{
	int					shmid;
    key_t				key;
    int					*shm;


	int					sockfd;
	struct sockaddr_in	servaddr;

	struct shmbuffarout_t	*shmbuffarout;

	char				outgoingbuff[MAXPKSIZE];

	char				localbuff[MAXPKSIZE*MAXBuffNum];
	int					localbuffsize;

	struct ipv6_t		*ipv6pk;
	int					i;
	int					count;


	key=SHMKEYbuffarout;
	if ((shmid = shmget(key, 0, 0666)) < 0) 
	{
       printf("share memory access error!\n");
	   exit(1);
    }

    if ((shm = shmat(shmid, NULL, 0)) == (int *) -1) {
        printf("share memory attatch error!\n");
        exit(1);
    }

	shmbuffarout=(struct shmbuffarout_t *)shm;

	count=0;

	for (; ;)
	{
		if (shmbuffarout->shmrealsize<=0)
			printf("In aroutedif: nothing to send yet, wait...\n");
		while (shmbuffarout->shmrealsize<=0)
			usleep(100); // waiting if empty buff
				
		if (shmbuffarout->shmwriting==1)
			printf("In aroutedif, somebody else is writing shmbuffarout, wait...\n");
		while (shmbuffarout->shmwriting==1)
			usleep(100); //busy waiting if sb else is writing
		shmbuffarout->shmwriting=1; //block out writing from other thread
		
		for (i=0; i<shmbuffarout->shmrealsize; i++)
			bcopy(shmbuffarout->shmbuff+i*MAXPKSIZE, localbuff+i*MAXPKSIZE, MAXPKSIZE); //copy to local
		localbuffsize=shmbuffarout->shmrealsize;

		shmbuffarout->shmrealsize=0; //update shmbuffarout size

		shmbuffarout->shmwriting=0; //release lock


		for (i=0; i<localbuffsize; i++)
		{
			bcopy(localbuff+i*MAXPKSIZE, outgoingbuff, MAXPKSIZE); //copy the head to send
			
			ipv6pk=(struct ipv6_t *)outgoingbuff;
			//printf("version: %d, ipv6 payloadlen: %d\n", ipv6pk->version, ipv6pk->payloadlen);

			if ( (sockfd = socket(AF_INET, SOCK_STREAM, 0))<0)
			{	
				printf("Sockfd creation error!\n");
				exit (-1);
			}

			bzero(&servaddr, sizeof(servaddr));
			servaddr.sin_family = AF_INET;
			servaddr.sin_port = htons(EUListenPort);
			inet_aton(ipv6pk->destinaddr, &servaddr.sin_addr);

			if ( (connect(sockfd, (struct sockaddr *) &servaddr, sizeof(servaddr)))<0)
			{
				printf("Connection Error! Maybe no server is running!\n");
				exit (-1);
			}

			if ( (write(sockfd, outgoingbuff, MAXPKSIZE))<0)
			{
				printf("Write socket error!\n");
				exit (-1);
			}
	
			close(sockfd);



			count++;
			if (count%20==0)
			{
				times(&tmss);
				printf(" (package#%d): utime=%d, stime=%d, total=%d\n", count, tmss.tms_utime, tmss.tms_stime, tmss.tms_utime+tmss.tms_stime);
					
			}
		}//end of inner for loop
	
	}

	return (0);
}
