#include	"common.h"

struct tms tmss;

int
main(int argc, char **argv)
{
	int					shmid;
    key_t				key;
    int					*shm;
	struct shmbuffcp_t	*shmbuffcp;
	int					sockfd;
	struct sockaddr_in	servaddr;
	char				outgoingbuff[MAXPKSIZE];
	int					i;
	char				localbuff[MAXPKSIZE*MAXBuffNum];
	struct ipv6_t		*ipv6pk;
	int					localbuffsize;
	int					count;
	int					failtime;

	key=SHMKEYcp;
	if ((shmid = shmget(key, 0, 0666)) < 0) 
	{
       printf("share memory access error!\n");
	   exit(-1);
    }

    if ((shm = shmat(shmid, NULL, 0)) == (int *) -1) {
        printf("share memory attatch error!\n");
        exit(-1);
    }

	shmbuffcp = (struct shmbuffcp_t *)shm;
	
	if (argc != 2)
	{
		printf("usage: cpsenderfsf <Router IPaddress>\n");
		exit (-1);
	}

	for (; ;)
	{
		if (shmbuffcp->shmrealsize<=0)
			printf("In aroutedif: nothing to send yet, wait...\n");
		while (shmbuffcp->shmrealsize<=0)
			usleep(100); // waiting if empty buff
				
		if (shmbuffcp->shmwriting==1)
			printf("In aroutedif, somebody else is writing shmbuffcp, wait...\n");
		while (shmbuffcp->shmwriting==1)
			usleep(100); //busy waiting if sb else is writing
		shmbuffcp->shmwriting=1; //block out writing from other thread
		
		for (i=0; i<shmbuffcp->shmrealsize; i++)
			bcopy(shmbuffcp->shmbuff+i*MAXPKSIZE, localbuff+i*MAXPKSIZE, MAXPKSIZE); //copy to local
		localbuffsize=shmbuffcp->shmrealsize;

		shmbuffcp->shmrealsize=0; //update shmbuffcp size

		shmbuffcp->shmwriting=0; //release lock


		for (i=0; i<localbuffsize; i++)
		{
			bcopy(localbuff+i*MAXPKSIZE, outgoingbuff, MAXPKSIZE); //copy the head to send
			
			ipv6pk=(struct ipv6_t *)outgoingbuff;
			//printf("version: %d, ipv6 payloadlen: %d\n", ipv6pk->version, ipv6pk->payloadlen);

			if ( (sockfd = socket(AF_INET, SOCK_STREAM, 0))<0)
			{	
				printf("Sockfd creation error!\n");
				exit (-1);
			}

			bzero(&servaddr, sizeof(servaddr));
			servaddr.sin_family = AF_INET;
			servaddr.sin_port = htons(RouterListenPort);
			inet_aton(argv[1], &servaddr.sin_addr);

			if ( (connect(sockfd, (struct sockaddr *) &servaddr, sizeof(servaddr)))<0)
			{
				printf("Connection Error! Retrying...\n");
				failtime=1;
				while ( (connect(sockfd, (struct sockaddr *) &servaddr, sizeof(servaddr)))<0)
				{
					usleep(10000);
					failtime++;
					if (failtime>100)
					{
						printf("Connection Error! No use for retry!\n");
						exit(-1);
					}
				}
				printf("retry#%d success! continue operating.\n", failtime);
			}

			if ( (write(sockfd, outgoingbuff, MAXPKSIZE))<0)
			{
				printf("Write socket error!\n");
				exit (-1);
			}
	
			close(sockfd);



			count++;
			if (count%20==0)
			{
				times(&tmss);
				printf(" (package#%d): utime=%d, stime=%d, total=%d\n", count, tmss.tms_utime, tmss.tms_stime, tmss.tms_utime+tmss.tms_stime);
					
			}
		}//end of inner for loop
	
	}

	exit (0);
}

